/**
 * Copyright 2005-2012 hdiv.org
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * 	http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.hdiv.exceptionHandler;

import javax.faces.context.ExceptionHandler;
import javax.faces.context.ExceptionHandlerFactory;

/**
 * <p>
 * HDIV's ExceptionHandler factory. Creates HDIVExceptionHandler instances for processing exceptions generated by HDIV.
 * </p>
 * <p>
 * Only for JSF 2.0+
 * </p>
 * 
 * @author Gotzon Illarramendi
 * 
 */
public class HDIVExceptionHandlerFactory extends ExceptionHandlerFactory {

	/**
	 * Original ExceptionHandlerFactory
	 */
	private ExceptionHandlerFactory original;

	/**
	 * Default constructor
	 * 
	 * @param original
	 *            original ExceptionHandlerFactory
	 */
	public HDIVExceptionHandlerFactory(ExceptionHandlerFactory original) {
		this.original = original;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see javax.faces.context.ExceptionHandlerFactory#getExceptionHandler()
	 */
	public ExceptionHandler getExceptionHandler() {

		ExceptionHandler exceptionHandler = this.original.getExceptionHandler();
		HDIVExceptionHandler hdivExHandler = new HDIVExceptionHandler(exceptionHandler);
		return hdivExHandler;
	}

}